function AaoPfdLink() {
	var AAO_URL_PART = "http://localhost:";
	var lastAaoSend = '';
	var dloop;
	var lastString = "";

	function DataLoop () {
		let apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number');
		if (apiport != 0) {
			let requestObj = {};
			requestObj.setstringvars = [];
			requestObj.setvars = [];
			// read softkey labels
			let currStr = "";
			let skeys = document.getElementsByClassName("softkey-tab-label");
			let svals = document.getElementsByClassName("softkey-tab-value");
			let sinds = document.getElementsByClassName("softkey-tab-indicator");
			for (let i = 0; i < 12; i++){
				let sval = "";
				let indval = 0;
				let enval = 1;
				if (skeys[i] && skeys[i].textContent.length > 0)
				{
					if (skeys[i].parentElement.className.indexOf("text-disabled") > 0){
						enval = 0;
					}
					sval = skeys[i].textContent;
				}
				if (svals[i] && svals[i].innerHTML.length > 0){
					sval = sval + " | " + svals[i].innerHTML;
				}
				if (sinds[i] && sinds[i].className.indexOf("shown") > 0){
					if (sinds[i].className.indexOf("indicating") > 0){
						indval = 2;
					} else {
						indval = 1;
					}
				}
				currStr = currStr + "_" + sval + indval.toString() + enval.toString();
				let toset = { "var": "(L:G1000_PFD_SOFTKEY_" + (i + 1).toString() + ", String)", "value": sval };
				requestObj.setstringvars.push(toset);
				toset = { "var": "(L:G1000_PFD_SOFTKEY_" + (i + 1).toString() + "_INDICATOR)", "value": indval };
				requestObj.setvars.push(toset);
				toset = { "var": "(L:G1000_PFD_SOFTKEY_" + (i + 1).toString() + "_ENABLED)", "value": enval };
				requestObj.setvars.push(toset);
				
			}
			let popdlg = document.getElementsByClassName("pfd-dto");
			let mtval = "";
			if (popdlg.length > 0 && popdlg[0].className.indexOf("open") > 0){
				let wpinp = popdlg[0].getElementsByClassName("input-component-value");
				if (wpinp.length > 0){
					mtval = wpinp[0].innerText;
				}
			}
			let mtoset = { "var": "(L:G1000_PFD_DTO_INP, String)", "value": mtval };
			requestObj.setstringvars.push(mtoset);
			currStr = currStr + "_" + mtval;
			popdlg = document.getElementsByClassName("pfd-wptinfo");
			mtval = "";
			if (popdlg.length > 0 && popdlg[0].className.indexOf("open") > 0){
				let wpinp = popdlg[0].getElementsByClassName("input-component-value");
				if (wpinp.length > 0){
					mtval = wpinp[0].innerText;
				}
			}
			mtoset = { "var": "(L:G1000_PFD_WPT_INP, String)", "value": mtval };
			requestObj.setstringvars.push(mtoset);
			currStr = currStr + "_" + mtval;
			let mdiv = document.getElementById("CenterBarTopLeft");
			mtval = "";
			if (mdiv){
				let dflds = mdiv.getElementsByClassName("dataField");
				for (let m = 0; m < dflds.length; m++){
					mtval = mtval + dflds[m].innerText + " - ";
				}
				if (mtval.length >= 3) mtval = mtval.substring(0, mtval.length - 3);
			}
			mtoset = { "var": "(L:G1000_PFD_AP_RTE, String)", "value": mtval };
			requestObj.setstringvars.push(mtoset);
			currStr = currStr + "_" + mtval;
			if (currStr !== lastString){
				lastString = currStr;
				let relxhttp = new XMLHttpRequest();
				let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
				relxhttp.open("POST", relurl);
				relxhttp.send(JSON.stringify(requestObj));
			}
		}
	};

	this.startup = function () {
		dloop = setInterval(DataLoop, 150);
	};
	
	this.shutdown = function () {
		clearInterval(dloop);
	};
};

var aaopfdmodule = new AaoPfdLink();
aaopfdmodule.startup();
